=begin
(c) TIG 2010
Adds a Prefix to selected text or text inside selected group/instance-definitions
To use - select the objects needing prefixes [text OR groups containing text etc]
then in the Ruby Console type 'prefixtext' + <enter> [note: the '' are NOT needed].
A dislog asks for the Prefix Text - enter it and OK - e.g. A.
All text in the selction is prefixed with the desired prefix e.g. 9 becomes A9 etc...
It is for use after running tools like Slicer 
- where sub-sets of slices might be more useful if they are differently coded.
Errors will stop you if there is no selction or you enter a blank 'prefix'.
It is one step un-doable.
=end
require 'sketchup.rb'
def prefixtext()
  model=Sketchup.active_model
  ents=model.active_entities
  ss=model.selection
  ssa=ss.to_a
  if not ssa
    UI.messagebox("Select some text or group/instance[s] containing text \nthat is to get a 'prefix', then run...")
    return nil
  end#if
  results=inputbox(["Enter Prefix Text: "],[""],"Text Prefix")
  return nil if not results
  prefix=results[0]
  if prefix==""
    UI.messagebox("'Prefix' cannot be '' - try again...")
    return nil
  end#if
 def doprefix(entsa=[], prefix="")
  entsa.each{|e|
    if e.class==Sketchup::Text
      e.text=prefix+e.text
    elsif e.class==Sketchup::Group
      doprefix(e.entities.to_a, prefix)
    elsif e.class==Sketchup::ComponentInstance
      doprefix(e.definition.entities.to_a, prefix)
    end#if
  }
 end#def
 model.start_operation("Prefix Text")
 doprefix(ssa, prefix)
 model.commit_operation
end#def